#!/system/bin/sh

################################################################################
# helper functions to allow Android init like script

function write() {
    echo -n $2 > $1
}

function copy() {
    cat $1 > $2
}
################################################################################

{

sleep 10

write /sys/module/msm_thermal/core_control/enabled 0
write /sys/module/msm_thermal/parameters/enabled "N"

# Disable sched_boost after boot complete
write /proc/sys/kernel/sched_boost 0

write /sys/module/lowmemorykiller/parameters/vmpressure_file_min 80640

write /sys/devices/system/cpu/cpu0/online 1
write /sys/devices/system/cpu/cpu2/online 1

chmod 0644 /sys/devices/system/cpu/cpu0/cpufreq/scaling_governor
chmod 0644 /sys/devices/system/cpu/cpu0/cpufreq/schedutil/*

# configure governor settings for silver cluster
write /sys/devices/system/cpu/cpu0/cpufreq/scaling_governor "schedutil"
write /sys/devices/system/cpu/cpu0/cpufreq/schedutil/up_rate_limit_us 250
write /sys/devices/system/cpu/cpu0/cpufreq/schedutil/down_rate_limit_us 1200
write /sys/devices/system/cpu/cpu0/cpufreq/schedutil/iowait_boost_enable 0

chmod 0644 /sys/devices/system/cpu/cpu2/cpufreq/scaling_governor
chmod 0644 /sys/devices/system/cpu/cpu2/cpufreq/schedutil/*

# configure governor settings for gold cluster
write /sys/devices/system/cpu/cpu2/cpufreq/scaling_governor "schedutil"
write /sys/devices/system/cpu/cpu2/cpufreq/schedutil/up_rate_limit_us 250
write /sys/devices/system/cpu/cpu2/cpufreq/schedutil/down_rate_limit_us 1200
write /sys/devices/system/cpu/cpu2/cpufreq/schedutil/iowait_boost_enable 0

write /sys/module/cpu_boost/parameters/dynamic_stune_boost 1

# Enable UFS powersaving
write /sys/devices/soc/${ro.boot.bootdevice}/clkscale_enable 1
write /sys/devices/soc/${ro.boot.bootdevice}/clkgate_enable 1
write /sys/devices/soc/${ro.boot.bootdevice}/${ro.boot.bootdevice}:ufs_variant/pm_qos_enable 1

# Set schedTune boost values (only affects EAS)
write /dev/stune/schedtune.sched_boost 30
write /dev/stune/rt/schedtune.sched_boost 50

# update cpusets now that boot is complete and we want better load balancing
write /dev/cpuset/top-app/cpus 0-3
write /dev/cpuset/foreground/boost/cpus 0-3
write /dev/cpuset/foreground/cpus 0-3
write /dev/cpuset/background/cpus 0
write /dev/cpuset/system-background/cpus 0-2

# Set swappiness and cache pressure
write /proc/sys/vm/swappiness 35
write /proc/sys/vm/vfs_cache_pressure 10
write /proc/sys/vm/dirty_ratio 20
write /proc/sys/vm/dirty_background_ratio 5

write /sys/block/dm-0/queue/read_ahead_kb 128
write /sys/block/sda/queue/read_ahead_kb 128
write /sys/block/sde/queue/read_ahead_kb 128
write /sys/block/dm-0/queue/scheduler cfq
write /sys/block/sda/queue/scheduler cfq
write /sys/block/sde/queue/scheduler cfq

write /sys/module/msm_thermal/core_control/enabled 0

setprop net.hostname Crimson

sleep 20

}&
